package testes.sialocacao.disciplina;

import sialocacao.*;
import sialocacao.disciplina.*;
import sialocacao.sala.*;
import sialocacao.timetabling.*;
import junit.framework.*;

import java.util.*;

public class DisciplinaTest extends TestCase{
  private SIAlocacao sia;

  public DisciplinaTest (String name){
    super(name);
    sia = new SIAlocacao();
  }

  public void testCadastrar(){
    try{
      String descricao = "disciplina"+System.currentTimeMillis();
      int cargaHoraria = 30;
      String ementa = "ementa"+System.currentTimeMillis();

      List categorias =
        sia.listarCategorias();

      Map prioridades =
        new HashMap();

      for(int i=0; i<categorias.size(); i++) {
        String codCategoria = ((Categoria)categorias.get(i)).getCodigo()+"";

        String codPreferencia =
          String.valueOf(TimetablingGenetico.PREFERENCIA_ALTA);

        prioridades.put(codCategoria, codPreferencia);
      }

      sia.inserirDisciplina(descricao, cargaHoraria, ementa, prioridades);

      Assert.assertTrue(true);// sucesso
    } catch(Exception e){
        e.printStackTrace();
        Assert.assertTrue(false);// erro
      }
  }


  public void testExcluir(){
    try{
      String descricao = "disciplina"+System.currentTimeMillis();
      int cargaHoraria = 30;
      String ementa = "ementa"+System.currentTimeMillis();

      List categorias =
        sia.listarCategorias();

      Map prioridades =
        new HashMap();

      for(int i=0; i<categorias.size(); i++) {
        String codCategoria = ((Categoria)categorias.get(i)).getCodigo()+"";

        String codPreferencia =
          String.valueOf(TimetablingGenetico.PREFERENCIA_ALTA);

        prioridades.put(codCategoria, codPreferencia);
      }

      sia.inserirDisciplina(descricao, cargaHoraria, ementa, prioridades);

      Disciplina disciplina =
        sia.buscarDisciplina(descricao);

      sia.excluirDisciplina(disciplina.getCodigo());

      Assert.assertTrue(true);// sucesso
    } catch(Exception e){
        e.printStackTrace();
        Assert.assertTrue(false);// erro
      }
  }

  public void testAlterar(){
    try{
      String descricao = "disciplina"+System.currentTimeMillis();
      int cargaHoraria = 30;
      String ementa = "ementa"+System.currentTimeMillis();

      List categorias =
        sia.listarCategorias();

      Map prioridades =
        new HashMap();

      for(int i=0; i<categorias.size(); i++) {
        String codCategoria = ((Categoria)categorias.get(i)).getCodigo()+"";

        String codPreferencia =
          String.valueOf(TimetablingGenetico.PREFERENCIA_ALTA);

        prioridades.put(codCategoria, codPreferencia);
      }

      sia.inserirDisciplina(descricao, cargaHoraria, ementa, prioridades);

      Disciplina disciplina =
        sia.buscarDisciplina(descricao);

      String novaDescricao = "disciplina"+System.currentTimeMillis();
      int novaCargaHoraria = 30;
      String novaEmenta = "ementa"+System.currentTimeMillis();

      disciplina.setDescricao(novaDescricao);
      disciplina.setCargaHoraria(novaCargaHoraria);
      disciplina.setEmenta(novaEmenta);

      sia.alterarDisciplina(disciplina, prioridades);

      Assert.assertTrue(true);// sucesso
    } catch(Exception e){
        e.printStackTrace();
        Assert.assertTrue(false);// erro
      }
  }

  public void testConsultar(){
    try{
      String descricao = "disciplina"+System.currentTimeMillis();
      int cargaHoraria = 30;
      String ementa = "ementa"+System.currentTimeMillis();

      List categorias =
        sia.listarCategorias();

      Map prioridades =
        new HashMap();

      for(int i=0; i<categorias.size(); i++) {
        String codCategoria = ((Categoria)categorias.get(i)).getCodigo()+"";

        String codPreferencia =
          String.valueOf(TimetablingGenetico.PREFERENCIA_ALTA);

        prioridades.put(codCategoria, codPreferencia);
      }

      sia.inserirDisciplina(descricao, cargaHoraria, ementa, prioridades);

      Disciplina disciplina =
        sia.buscarDisciplina(descricao);

      Assert.assertTrue(true);// sucesso
    } catch(Exception e){
        e.printStackTrace();
        Assert.assertTrue(false);// erro
      }
  }
}
