package testes.sialocacao.professor;

import junit.framework.*;

import sialocacao.*;
import sialocacao.professor.*;

public class ProfessorTest extends TestCase{
  private SIAlocacao sia;

  public ProfessorTest(String name){
    super(name);

    sia =
      new SIAlocacao();
  }

  public void testCadastrar(){
    try{
      String nome =
        "professor"+System.currentTimeMillis();

      String cpf =
        String.valueOf(System.currentTimeMillis());

      sia.inserirProfessor(nome, cpf);

      Assert.assertTrue(true);// sucesso
    }catch(Exception e){
       e.printStackTrace();
       Assert.assertTrue(false);// erro
     }
  }

  public void testAlterar(){
    try{
      String nome =
        "professor"+System.currentTimeMillis();

      String cpf =
        String.valueOf(System.currentTimeMillis());

      sia.inserirProfessor(nome, cpf);

      Professor professor =
        sia.buscarProfessor(nome);

      String cpfNovo =
        String.valueOf(System.currentTimeMillis());

      professor.setCpf(cpfNovo);

      sia.alterarProfessor(professor);

      Assert.assertTrue(true);// sucesso
    }catch(Exception e){
       e.printStackTrace();
       Assert.assertTrue(false);// erro
     }
  }

  public void testExcluir(){
    try{
      String nome =
        "professor"+System.currentTimeMillis();

      String cpf =
        String.valueOf(System.currentTimeMillis());

      sia.inserirProfessor(nome, cpf);

      Professor professor =
        sia.buscarProfessor(nome);

      sia.excluirProfessor(professor.getCodigo());

      Assert.assertTrue(true);// sucesso
    }catch(Exception e){
       e.printStackTrace();
       Assert.assertTrue(false);// erro
     }
  }

  public void testBuscar(){
    try{
      String nome =
        "professor"+System.currentTimeMillis();

      String cpf =
        String.valueOf(System.currentTimeMillis());

      sia.inserirProfessor(nome, cpf);

      Professor professor =
        sia.buscarProfessor(nome);

      Assert.assertTrue(true);// sucesso
    }catch(Exception e){
       e.printStackTrace();
       Assert.assertTrue(false);// erro
     }
  }
}