package testes.sialocacao.sala;

import junit.framework.*;

import sialocacao.*;
import sialocacao.sala.*;

public class SalaTest extends TestCase{
  private SIAlocacao sia;

  public SalaTest(String name){
    super(name);

    sia =
      new SIAlocacao();
  }

  public void testCadastrar(){
    try{
      String descricao =
        "sala"+System.currentTimeMillis();

      String localizacao =
        "sala"+System.currentTimeMillis();

      String observacao =
        "sala"+System.currentTimeMillis();

      int categoria = 2;

      sia.inserirSala(descricao, localizacao, observacao, categoria);

      Assert.assertTrue(true);// sucesso
    }catch(Exception e){
       e.printStackTrace();
       Assert.assertTrue(false);// erro
     }
  }

  public void testAlterar(){
    try{
      String descricao =
        "sala"+System.currentTimeMillis();

      String localizacao =
        "sala"+System.currentTimeMillis();

      String observacao =
        "sala"+System.currentTimeMillis();

      int categoria = 2;

      sia.inserirSala(descricao, localizacao, observacao, categoria);

      Sala sala =
        sia.buscarSala(descricao);

      String novaLocalizacao =
        "sala"+System.currentTimeMillis();

      String novaObservacao =
        "sala"+System.currentTimeMillis();

      int novaCategoria = 3;

      sala.setLocalizacao(novaLocalizacao);
      sala.setObservacao(novaObservacao);
      sala.setCodigoCategoria(novaCategoria);

      sia.alterarSala(sala);

      Assert.assertTrue(true);// sucesso
    }catch(Exception e){
       e.printStackTrace();
       Assert.assertTrue(false);// erro
     }
  }

  public void testExcluir(){
    try{
      String descricao =
        "sala"+System.currentTimeMillis();

      String localizacao =
        "sala"+System.currentTimeMillis();

      String observacao =
        "sala"+System.currentTimeMillis();

      int categoria = 2;

      sia.inserirSala(descricao, localizacao, observacao, categoria);

      Sala sala =
        sia.buscarSala(descricao);

      sia.excluirSala(sala.getCodigo());

      Assert.assertTrue(true);// sucesso
    }catch(Exception e){
       e.printStackTrace();
       Assert.assertTrue(false);// erro
     }
  }

  public void testBuscar(){
    try{
      String descricao =
        "sala"+System.currentTimeMillis();

      String localizacao =
        "sala"+System.currentTimeMillis();

      String observacao =
        "sala"+System.currentTimeMillis();

      int categoria = 2;

      sia.inserirSala(descricao, localizacao, observacao, categoria);

      Sala sala =
        sia.buscarSala(descricao);

      Assert.assertTrue(true);// sucesso
    }catch(Exception e){
       e.printStackTrace();
       Assert.assertTrue(false);// erro
     }
  }
}